IF OBJECT_ID('[Environments_Extended]') IS NOT NULL	DROP VIEW [Environments_Extended]
GO

CREATE VIEW [Environments_Extended]
AS
	SELECT E.*
          ,[Parent_Environment_Name] = E_PARENT.[Environment_Name]
          
          ,[Roles_Count] = (SELECT COUNT(DISTINCT SRS.[ServerRole_Id])
                              FROM [EnvironmentServers] ES
                       CROSS APPLY dbo.Environments_GetAncestorEnvironments(ES.[Environment_Id]) AE
                        INNER JOIN [ServerRoleServers] SRS
                                ON SRS.[Server_Id] = ES.[Server_Id]
                             WHERE AE.[Environment_Id] = E.[Environment_Id])
          
          ,[Servers_Count] = (SELECT COUNT(DISTINCT ES.[Server_Id])
                              FROM [EnvironmentServers] ES
                       CROSS APPLY dbo.Environments_GetAncestorEnvironments(ES.[Environment_Id]) AE
                             WHERE AE.[Environment_Id] = E.[Environment_Id])

		  ,[Aggregate_ServerConfiguration_Status_Code] = CASE WHEN ES_DRIFT.[Priority_Index] < 2 THEN 'D' WHEN ES_DRIFT.[Priority_Index] >= 2 THEN 'C' ELSE 'U' END

		  ,[Descendants_Aggregate_ServerConfiguration_Status_Code] = CASE WHEN D_DRIFT.[Priority_Index] < 2 THEN 'D' WHEN D_DRIFT.[Priority_Index] >= 2 THEN 'C' ELSE 'U' END

	  FROM [Environments] E
 
 LEFT JOIN [Environments] E_PARENT
        ON E_PARENT.[Environment_Id] = E.[Parent_Environment_Id]

 LEFT JOIN (SELECT [Environment_Id],
                   [Priority_Index] = MIN(SC_DRIFT.[Priority_Index])
              FROM [EnvironmentServers] ES
                   LEFT JOIN (SELECT [Server_Id],
                                     [Priority_Index] = MIN([ServerConfiguration_Status_Priority])
                                FROM [ServerConfigurations]
                               GROUP BY [Server_Id]) SC_DRIFT
						  ON SC_DRIFT.[Server_Id] = ES.[Server_Id]
			 GROUP BY ES.[Environment_Id]) ES_DRIFT
				ON ES_DRIFT.[Environment_Id] = E.[Environment_Id]

 LEFT JOIN (SELECT ES.[Environment_Id],
                   [Priority_Index] = MIN(SC.[ServerConfiguration_Status_Priority])
              FROM [EnvironmentServers] ES 
                   CROSS APPLY dbo.Environments_GetAncestorEnvironments(ES.[Environment_Id]) AE
                   INNER JOIN [ServerConfigurations] SC
                           ON ES.[Server_Id] = SC.[Server_Id]
			 GROUP BY ES.[Environment_Id]) D_DRIFT
	    ON D_DRIFT.[Environment_Id] = E.[Environment_Id]

GO
