EXEC [dbo].[__AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_UpdateJobState',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Updates the state of the specified job.'
GO
 

IF OBJECT_ID('[Executions_UpdateJobState]') IS NOT NULL DROP PROCEDURE [Executions_UpdateJobState]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_UpdateJobState]
(
    @Job_Id INT,
    @JobState_Code CHAR(1),
    @LastRun_Date DATETIME = NULL
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION
    
	UPDATE [Jobs]
       SET [JobState_Code] = @JobState_Code,
           [LastRun_Date] = COALESCE(@LastRun_Date, [LastRun_Date])
     WHERE [Job_Id] = @Job_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH


END
GO

GRANT EXECUTE ON [Executions_UpdateJobState] TO [OtterUser_Role]
