EXEC [dbo].[__AddStoredProcInfo]
    /* StoredProc_Name         */ 'Servers_GetServersSlim',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Servers_Slim',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all the servers in the system.'
GO

IF OBJECT_ID('[Servers_GetServersSlim]') IS NOT NULL DROP PROCEDURE [Servers_GetServersSlim]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Servers_GetServersSlim]
(
	@IncludeInactive_Indicator YNINDICATOR = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT S.* 
	  FROM [Servers_Slim] S
	 WHERE @IncludeInactive_Indicator = 'Y' OR [Active_Indicator] = 'Y'
	ORDER BY [Server_Name] 

END
GO

GRANT EXECUTE ON [Servers_GetServersSlim] TO [OtterUser_Role]

